/*
	DomainQuery.cpp

	Implemetation of class DomainQuery

	This file was generated by dalcg v2.3-4
	Created Sat, 03 Sep 2011 08:21:51 EDT (UTC-0400)

	$Id: DomainQuery.cpp 689 2018-11-28 17:54:35Z john $
*/

#include <Auth4cDal/DomainQuery.h>

#include <librfcdal/SqlSelectStatement.h>
#include <librfcdal/SqlInsertStatement.h>
#include <librfcdal/SqlUpdateStatement.h>
#include <librfcdal/SqlDeleteStatement.h>

#if defined (DEBUG)
#	include <iostream>
#endif /* DEBUG */

Auth4cDal::DomainQuery::DomainQuery( const RfcDal::SqlSchema& schema )
	: DomainQueryBase( schema )
{
}

Auth4cDal::DomainQuery::DomainQuery( const RfcDal::SqlTable& table )
	: DomainQueryBase( table )
{
}

Auth4cDal::DomainQuery::~DomainQuery()
{
}

void Auth4cDal::DomainQuery::constrainCustomer( const RfcDal::SqlColumnPtr& value )
{
	_valCustomerConstraint = value;
}

void Auth4cDal::DomainQuery::addConstraints( RfcDal::SqlCompoundCondition& conditionS, bool bAddBaseConstraints /*= true*/ ) 
{
	if( bAddBaseConstraints )
	{
		DomainQueryBase::addConstraints( conditionS );
	}

	if( _valCustomerConstraint.isValid() )
	{
		RfcDal::SqlCondition condCustomer( _colCustomer, _valCustomerConstraint, RfcDal::SqlCondition::condEqual );
		conditionS.addCondition( condCustomer );
	}
}

int Auth4cDal::DomainQuery::select( RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& database, RfcDal::SqlQueryBase::QueryType type ) 
{
	RfcDal::SqlSelectStatement statement( _tbDomain );

	addColumns( statement, RfcDal::SqlQueryBase::invalidToo );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

	if( condition.count() )
		statement.setWhere( condition );

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( result, statement );
}

int Auth4cDal::DomainQuery::insert( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlInsertStatement statement( _tbDomain );

	addColumns( statement, RfcDal::SqlQueryBase::validOnly );

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}

int Auth4cDal::DomainQuery::update( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlUpdateStatement statement( _tbDomain );

	addColumns( statement, RfcDal::SqlQueryBase::validOnly );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

// If no constraint is set, this function would update/delete all rows in the table.
// If you want to be able to do this (not recommended), remove "else return 0;"

	if( condition.count() )
		statement.setWhere( condition );
	else
		return 0;

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}

int Auth4cDal::DomainQuery::remove( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlDeleteStatement statement( _tbDomain );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

// If no constraint is set, this function would update/delete all rows in the table.
// If you want to be able to do this (not recommended), remove "else return 0;"

	if( condition.count() )
		statement.setWhere( condition );
	else
		return 0;

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}
