/*
	ProductQuery.cpp

	Implemetation of class ProductQuery

	This file was generated by dalcg v2.3-4
	Created Sat, 03 Sep 2011 08:21:51 EDT (UTC-0400)

	$Id: ProductQuery.cpp 689 2018-11-28 17:54:35Z john $
*/

#include <Auth4cDal/ProductQuery.h>

#include <librfcdal/SqlSelectStatement.h>
#include <librfcdal/SqlInsertStatement.h>
#include <librfcdal/SqlUpdateStatement.h>
#include <librfcdal/SqlDeleteStatement.h>
#include <librfcdal/SqlFunction.h>

#if defined (DEBUG)
#	include <iostream>
#endif /* DEBUG */

Auth4cDal::ProductQuery::ProductQuery( const RfcDal::SqlSchema& schema )
	: ProductQueryBase( schema )
{
}

Auth4cDal::ProductQuery::ProductQuery( const RfcDal::SqlTable& table )
	: ProductQueryBase( table )
{
}

Auth4cDal::ProductQuery::~ProductQuery()
{
}

void Auth4cDal::ProductQuery::addConstraints( RfcDal::SqlCompoundCondition& conditionS, bool bAddBaseConstraints /*= true*/ ) 
{
	if( bAddBaseConstraints )
	{
		ProductQueryBase::addConstraints( conditionS );
	}
}

int Auth4cDal::ProductQuery::select( RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& database, RfcDal::SqlQueryBase::QueryType type ) 
{
	RfcDal::SqlSelectStatement statement( _tbProduct );

	switch( type )
	{
		case max: //specific to nextProduct in Auth4cDataDB
		{
			RfcDal::SqlFunction fnMax( "MAX" );
			fnMax.addColumn( columnProduct() );
			statement.addColumn( fnMax );
			break;
		}

		case brief:
		case full:
		case min:
		case count:
			addColumns( statement, RfcDal::SqlQueryBase::invalidToo );
			break;
	}

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

	if( condition.count() )
		statement.setWhere( condition );

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( result, statement );
}

int Auth4cDal::ProductQuery::insert( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlInsertStatement statement( _tbProduct );

	addColumns( statement, RfcDal::SqlQueryBase::validOnly );

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}

int Auth4cDal::ProductQuery::update( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlUpdateStatement statement( _tbProduct );

	addColumns( statement, RfcDal::SqlQueryBase::validOnly );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

// If no constraint is set, this function would update/delete all rows in the table.
// If you want to be able to do this (not recommended), remove "else return 0;"

	if( condition.count() )
		statement.setWhere( condition );
	else
		return 0;

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}

int Auth4cDal::ProductQuery::remove( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlDeleteStatement statement( _tbProduct );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

// If no constraint is set, this function would update/delete all rows in the table.
// If you want to be able to do this (not recommended), remove "else return 0;"

	if( condition.count() )
		statement.setWhere( condition );
	else
		return 0;

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}
