/*
	UserQuery.cpp

	Implemetation of class UserQuery

	This file was generated by dalcg v2.3-4
	Created Sat, 03 Sep 2011 08:21:51 EDT (UTC-0400)

	$Id: UserQuery.cpp 689 2018-11-28 17:54:35Z john $
*/

#include <Auth4cDal/UserQuery.h>

#include <librfcdal/SqlSelectStatement.h>
#include <librfcdal/SqlInsertStatement.h>
#include <librfcdal/SqlUpdateStatement.h>
#include <librfcdal/SqlDeleteStatement.h>

#if defined (DEBUG)
#	include <iostream>
#endif /* DEBUG */

Auth4cDal::UserQuery::UserQuery( const RfcDal::SqlSchema& schema )
	: UserQueryBase( schema )
{
}

Auth4cDal::UserQuery::UserQuery( const RfcDal::SqlTable& table )
	: UserQueryBase( table )
{
}

Auth4cDal::UserQuery::~UserQuery()
{
}

void Auth4cDal::UserQuery::constrainAuthenticationToken( const RfcDal::SqlColumnPtr& value )
{
	_valAuthenticationTokenConstraint = value;
}

void Auth4cDal::UserQuery::constrainSearch( const RfcDal::SqlValue& value )
{
	_valSearchConstraint = value;
}

void Auth4cDal::UserQuery::addConstraints( RfcDal::SqlCompoundCondition& conditionS, bool bAddBaseConstraints /*= true*/ ) 
{
	if( bAddBaseConstraints )
	{
		UserQueryBase::addConstraints( conditionS );
	}

	if( _valAuthenticationTokenConstraint.isValid() )
	{
		RfcDal::SqlCondition condAuthenticationToken( _colAuthenticationToken, _valAuthenticationTokenConstraint, RfcDal::SqlCondition::condEqual );
		conditionS.addCondition( condAuthenticationToken );
	}

	if ( _valSearchConstraint.isValid() )
	{
		RfcDal::SqlCondition condId( _colUserId, _valSearchConstraint, RfcDal::SqlCondition::condLike , RfcDal::SqlCondition::SqlConditionModifier::likeBoth );
		RfcDal::SqlCondition condName( _colName, _valSearchConstraint, RfcDal::SqlCondition::condLike , RfcDal::SqlCondition::SqlConditionModifier::likeBoth );
			
		RfcDal::SqlCompoundCondition condSearch( RfcDal::SqlCompoundCondition::compOr );
		condSearch.addCondition( condId );
		condSearch.addCondition( condName );

		conditionS.addCondition( condSearch );
	}
}

int Auth4cDal::UserQuery::select( RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& database, RfcDal::SqlQueryBase::QueryType type ) 
{
	RfcDal::SqlSelectStatement statement( _tbUser );

	addColumns( statement, RfcDal::SqlQueryBase::invalidToo );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

	if( condition.count() )
		statement.setWhere( condition );

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( result, statement );
}

int Auth4cDal::UserQuery::insert( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlInsertStatement statement( _tbUser );

	addColumns( statement, RfcDal::SqlQueryBase::validOnly );

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}

int Auth4cDal::UserQuery::update( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlUpdateStatement statement( _tbUser );

	addColumns( statement, RfcDal::SqlQueryBase::validOnly );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

// If no constraint is set, this function would update/delete all rows in the table.
// If you want to be able to do this (not recommended), remove "else return 0;"

	if( condition.count() )
		statement.setWhere( condition );
	else
		return 0;

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}

int Auth4cDal::UserQuery::remove( RfcDal::DalDatabase& database ) 
{
	RfcDal::SqlDeleteStatement statement( _tbUser );

	RfcDal::SqlCompoundCondition condition( RfcDal::SqlCompoundCondition::compAnd );

	addConstraints( condition );

// If no constraint is set, this function would update/delete all rows in the table.
// If you want to be able to do this (not recommended), remove "else return 0;"

	if( condition.count() )
		statement.setWhere( condition );
	else
		return 0;

#if defined (DEBUG)
	std::cout << statement.toSql( database.language() ) << std::endl;
#endif /* DEBUG */

	return database.execute( statement );
}
