/*

  $Id: Customer.cpp 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cData/Customer.h>

#include <Auth4cData/User.h>

using namespace Auth4cData;

const Customer Customer::allCustomers( "*" );

Customer::Customer()
{
}

Customer::Customer( const std::string& strCustomer,
			const std::string& strName )
	: _strCustomer( strCustomer ),
	_strName( strName )
{
}

Customer::Customer( const Customer& customer )
	: _strCustomer( customer._strCustomer ),
	_strName( customer._strName ),
	_domainS( customer._domainS ),
	_teamS( customer._teamS )
{
}

Customer::~Customer()
{
}

const Customer& Customer::operator=( const Customer& customer )
{
	if( this != &customer )
	{
		_strCustomer = customer._strCustomer;
		_strName = customer._strName;
		_domainS = customer._domainS;
		_teamS = customer._teamS;
	}

	return *this;
}

const std::string& Customer::customer() const
{
	return _strCustomer;
}

const std::string& Customer::name() const
{
	return _strName;
}

const DomainPtrMap& Customer::domains() const
{
	return _domainS;
}

const TeamPtrMap& Customer::teams() const
{
	return _teamS;
}

void Customer::setName( const std::string& strName )
{
	_strName = strName;
}

DomainPtrMap& Customer::domains()
{
	return _domainS;
}

TeamPtrMap& Customer::teams()
{
	return _teamS;
}
