/*

  $Id: Profile.cpp 607 2017-05-26 13:06:51Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cData/Profile.h>

using namespace Auth4cData;

Profile::Profile( const std::string& strProfile /*= std::string()*/, bool bDefault /*= false*/ )
	: _strProfile( strProfile ),
	_bDefault( bDefault )
{
}

Profile::Profile( const Profile& profile )
	: _strProfile( profile._strProfile ),
	_bDefault( profile._bDefault ),
	_productS( profile._productS )
{
}

Profile::~Profile()
{
}

const Profile& Profile::operator=( const Profile& profile )
{
	if( this != &profile )
	{
		_strProfile = profile._strProfile;
		_bDefault = profile._bDefault;
		_productS = profile._productS;
	}

	return *this;
}

const std::string& Profile::profile() const
{
	return _strProfile;
}

bool Profile::isDefault() const
{
	return _bDefault;
}

const ProductInitMap& Profile::products() const
{
	return _productS;
}

void Profile::setProducts( const ProductInitMap& productS )
{
	_productS = productS;
}


//////////////////////////////////////////////////////////////////////////
//
// ProfileMap
//

ProfileMap::ProfileMap()
{
}

ProfileMap::ProfileMap( const ProfileMap& profileS )
	: std::map<std::string, Profile>( profileS )
{
}

ProfileMap::~ProfileMap()
{
}

const ProfileMap& ProfileMap::operator=( const ProfileMap& profileS )
{
	if( this != &profileS )
	{
		std::map<std::string, Profile>::operator=( profileS );
	}

	return *this;
}
