/*

  $Id: Session.cpp 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cData/Session.h>

#include <time.h>

using namespace Auth4cData;

int Session::_nTimeout( 1800 );

Session::Session()
	: _tAccessed( -1 )
{
}

Session::Session( const std::string& strSessionId )
	: _strSessionId( strSessionId ),
	_tAccessed( -1 )
{
}

Session::Session( const Session& session )
	: _strSessionId( session._strSessionId ),
	_tAccessed( session._tAccessed )
{
}

Session::~Session()
{
}

const Session& Session::operator=( const Session& session )
{
	if( this != &session )
	{
		_strSessionId = session._strSessionId;
		_tAccessed = session._tAccessed;
	}

	return *this;
}

const std::string& Session::str() const
{
	return _strSessionId;
}

Session* Session::copy() const
{
	return new Session( *this );
}

void Session::setSessionTimeout( int nSeconds )
{
	_nTimeout = nSeconds;
}

void Session::access() 
{
	time_t tNow = time( NULL );
	if( ( -1 != _tAccessed ) &&
		( ( _tAccessed + _nTimeout ) < tNow ) )
	{
		throw Auth4cData::Exception( __FILE__, __LINE__, Auth4cData::nNAX_BADSESSION, "Session timed out." );
	}

	_tAccessed = tNow;
}
