/*

  $Id: TeamMember.cpp 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cData/TeamMember.h>

using namespace Auth4cData;

TeamMember::TeamMember()
{
}

TeamMember::TeamMember( User user, bool bIsLead )
	: User( user ),
	_bIsLead( bIsLead )
{
}

TeamMember::TeamMember( const TeamMember& member )
	: User( member ),
	_bIsLead( member._bIsLead )
{
}

TeamMember::~TeamMember()
{
}

const TeamMember& TeamMember::operator=( const TeamMember& member )
{
	if( this != &member )
	{
		User::operator =( member );
		_bIsLead = member._bIsLead;
	}

	return *this;
}

bool TeamMember::isLead() const
{
	return _bIsLead;
}

void TeamMember::setLead( bool bIsLead )
{
	_bIsLead = bIsLead;
}
