/*

  $Id: XTeam.cpp 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cData/XTeam.h>

using namespace Auth4cData;

XTeam::XTeam()
	: _nTeam( -1 )
{
}

XTeam::XTeam( const std::string& strDomain,
		const std::string& strAlienGroup,
		const std::string& strAlienGroupLeadGroup,
		int nTeam )
	: _strDomain( strDomain ),
	_strAlienGroup( strAlienGroup ),
	_strAlienGroupLeadGroup( strAlienGroupLeadGroup ),
	_nTeam( nTeam ),
	_keyAlien( std::make_pair( _strDomain, _strAlienGroup ) ),
	_keyAlienMap( std::make_pair( _keyAlien, _nTeam ) )
{
}

XTeam::XTeam( const XTeam& team )
	: _strDomain( team._strDomain ),
	_strAlienGroup( team._strAlienGroup ),
	_strAlienGroupLeadGroup( team._strAlienGroupLeadGroup ),
	_nTeam( team._nTeam ),
	_keyAlien( team._keyAlien ),
	_keyAlienMap( team._keyAlienMap )
{
}

XTeam::~XTeam()
{
}

const XTeam& XTeam::operator=( const XTeam& team )
{
	if( this != &team )
	{
		_strDomain = team._strDomain;
		_strAlienGroup = team._strAlienGroup;
		_strAlienGroupLeadGroup = team._strAlienGroupLeadGroup;
		_nTeam = team._nTeam;
		_keyAlien = team._keyAlien;
		_keyAlienMap = team._keyAlienMap;
	}

	return *this;
}

const std::string& XTeam::domain() const
{
	return _strDomain;
}

const std::string& XTeam::alienGroup() const
{
	return _strAlienGroup;
}

const std::string& XTeam::alienGroupLeadGroup() const
{
	return _strAlienGroupLeadGroup;
}

int XTeam::team() const
{
	return _nTeam;
}

const AlienKey& XTeam::keyAlien() const
{
	return _keyAlien;
}

const AlienMapKey& XTeam::keyAlienMap() const
{
	return _keyAlienMap;
}
