/*

  $Id: Util.cpp 391 2015-12-08 19:50:07Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cDataXML/Util.h>

#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

Auth4cDataXML_Export int Auth4cDataXML::boo( std::string& strTarget, const unsigned char* pbySource, unsigned uSourceLen )
{
	int nRtn( 0 );
	strTarget = std::string();
	char szTemp[3];

	for( unsigned uIndex = 0; uIndex < uSourceLen; ++uIndex )
	{
#if defined (_WINDOWS)
		_snprintf( szTemp, 3, "%02x", pbySource[uIndex] );
#else
		snprintf( szTemp, 3, "%02x", pbySource[uIndex] );
#endif /* _WINDOWS */
		strTarget += szTemp;
	}

	return nRtn;
}

Auth4cDataXML_Export int Auth4cDataXML::deboo( unsigned char* pbyTarget, unsigned uTargetLen, const std::string& strSource )
{
	int nRtn( 0 );
	std::string strTemp;

	for( std::string::const_iterator iter = strSource.begin();
			iter != strSource.end();
			++iter )
	{
		strTemp += *iter;
		if( 2 == strTemp.length() )
		{
			pbyTarget[nRtn] = (unsigned char)strtoul( strTemp.c_str(), NULL, 16 );
			++nRtn;
			if( nRtn > (int)uTargetLen )
			{
				return (int)-1;
			}
			strTemp = std::string();
		}
	}

	return nRtn;
}

void dumpkeypart( char c, mp_int n )
{
	printf( "%c\n", c );
	printf( "sign=%i\nalloc=%i\nused=%i\n", n.sign, n.alloc, n.used );
	for( unsigned int nI = 0; nI < n.alloc; ++nI )
	{
		printf( "dp[%02x]=%04x  ", nI, n.dp[nI] );
		if( !( nI % 8 ) )
			printf( "\n" );
	}
}

Auth4cDataXML_Export void Auth4cDataXML::dumpkey( const struct rsa_key& key )
{
	printf( "Keytype = %s\n", key.type == PK_PRIVATE ? "Private" : " Public" );
	dumpkeypart( 'e', key.e );
	printf( "\n" );
	dumpkeypart( 'd', key.d );
	printf( "\n" );
	dumpkeypart( 'N', key.N );
	printf( "\n" );
}
