/*

  $Id: Auth4cMySQL.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4cMySQL_Auth4cMySQL_h__
#define __Auth4cMySQL_Auth4cMySQL_h__

#if defined (Auth4cMySQL_Export)
#	undef Auth4cMySQL_Export
#endif /* Auth4cMySQL_Export*/

#if defined (_WINDOWS)
#	include <windows.h>
#	if defined (AUTH4C`MYSQL_EXPORTS)
#		define Auth4cMySQL_Export __declspec( dllexport )
#	else
#		define Auth4cMySQL_Export __declspec( dllimport )
#	endif /* AUTH4CMYSQL_EXPORTS */
#	pragma warning( disable : 4355 4251 )
#else
#	define Auth4cMySQL_Export
#endif /* _WINDOWS */

#include <Auth4cAuth4c/Auth4cAuth4c.h>

#include <librfcdal/DalMySQLDatabase.h>

namespace Auth4cMySQL
{
	class Authenticator : public Auth4cAuth4c::Authenticator
	{
		private:
//			RfcDal::DalMySQLDatabase _db;

		public:
			Authenticator( const Auth4cData::InitMap& initAuthenticator,
							const Auth4cData::Domain& domain = Auth4cData::Domain(),
							const std::string& strDescription = std::string(),
							int nAuthenticationLibrary = 0 );
			Authenticator( const Authenticator& authenticator );
			virtual ~Authenticator();

			const Authenticator& operator=( const Authenticator& authenticator );

			virtual Auth4cData::AuthenticatedUser authenticate( const Auth4cData::User& user, const Auth4cData::AuthenticationToken& authToken, const Auth4cData::Profile& profile );

//			virtual bool passwd( const Auth4cData::AuthenticatedUser& user, Auth4cData::AuthenticationToken& authTokenCurrent, Auth4cData::AuthenticationToken& authTokenNew );

		protected:
			Auth4cData::AuthenticatedUser authenticate( const Auth4cData::User& user, const Auth4cData::AuthenticationToken& authToken, const Auth4cData::Profile& profile, RfcDal::DalDatabase& db );
			void init( RfcDal::DalDatabase& db );
	};

	class AuthenticationLibrary : public Auth4cData::AuthenticationLibrary
	{
		public:
			AuthenticationLibrary();
			AuthenticationLibrary( const Auth4cData::AuthenticationLibrary* ptemplate );
			AuthenticationLibrary( const AuthenticationLibrary& library );
			virtual ~AuthenticationLibrary();

			const AuthenticationLibrary& operator=( const AuthenticationLibrary& library );

			virtual Auth4cData::Authenticator* authenticator( const Auth4cData::Domain& domain,
																const std::string& strDescription,
																const Auth4cData::InitMap& initMap );
	};
};

#endif /* !__Auth4cMySQL_Auth4cMySQL_h__ */
