/*

  $Id: AboutAuth4cWidget.cpp 403 2015-12-10 14:13:42Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cUIComponents/AboutAuth4cWidget.h>

#include <Auth4cUIComponents/ExceptionDialog.h>

#include <Auth4cData/Factory.h>
#include <Auth4cDataXML/Auth4cFactory.h>
#include <Auth4cDataXML/Auth4cService.h>

#include <sstream>

using namespace Auth4cUIComponents;

AboutAuth4cWidget::AboutAuth4cWidget( QWidget* pparent )
	: QWidget( pparent )

{
    setupUi(this); //Setup the Qt Designer generated widgets

	const Base4c::DaemonComm& comm( Auth4cDataXML::Auth4cService::comm() );
	std::map<std::string, Base4c::Version> versionS = Auth4cDataXML::Factory::about();

	QString strAbout;

	strAbout = tr( "<strong>4c Auth4c</strong><br/>Copyright &copy; 2012, The 4c Company<br/><br/>" );
	strAbout += tr( "<br/><strong>Auth4c Client</strong><br/>&nbsp;" );
	strAbout += QString::fromStdString( Auth4cDataXML::Factory::version().textLS() );
	strAbout += tr( "<br/><br/><strong>Auth4c Server (" );
	strAbout += QString::fromStdString( comm.host() );
	strAbout += tr( ")</strong><br/>" );

	for( std::map<std::string, Base4c::Version>::const_iterator iter = versionS.begin();
			iter != versionS.end();
			++iter )
	{
		strAbout += tr( "&nbsp;" );
		strAbout += QString::fromStdString( iter->first );
		strAbout += tr( "&nbsp;" );
		strAbout += QString::fromStdString( iter->second.textLS() );
		strAbout += tr( "<br/>" );
	}

	_pedtAbout->setHtml( strAbout );
}

AboutAuth4cWidget::~AboutAuth4cWidget()
{
}
