/*

  $Id: AskUserDialog.cpp 403 2015-12-10 14:13:42Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cUIComponents/AskUserDialog.h>

#include <Auth4cData/Factory.h>

#include <QMessageBox>

#include <sstream>

using namespace Auth4cUIComponents;

AskUserDialog::AskUserDialog( QWidget* pparent )
	: QDialog( pparent )
{
    setupUi(this); //Setup the Qt Designer generated widgets

	Auth4cData::DomainMap& domainS( Auth4cData::Factory::domains() );

	for( Auth4cData::DomainMap::const_iterator iter = domainS.begin();
			iter != domainS.end();
			++iter )
	{
		_pcbxDomain->addItem( QString::fromStdString( iter->second.domain() ) );
	}
}

AskUserDialog::~AskUserDialog()
{
}

QString AskUserDialog::domain()
{
	return _pcbxDomain->currentText();
}

QString AskUserDialog::userId()
{
	return _pedtUserId->text();
}

void AskUserDialog::setDomain( const Auth4cData::Domain& domain, bool bRestrict /*= false*/ )
{
	int nIndex = _pcbxDomain->findText( QString::fromStdString( domain.domain() ) );

	if( -1 != nIndex )
	{
		_pcbxDomain->setCurrentIndex( nIndex );

		_pcbxDomain->setEnabled( !bRestrict );
	}
}
