/*

  $Id: ExceptionDialog.cpp 688 2018-11-28 17:10:21Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cUIComponents/ExceptionDialog.h>

#include <Auth4cUIComponents/Auth4cUIComponents.h>

#include <Auth4cDataXML/Auth4cFactory.h>

#include <QMessageBox>
#include <QClipboard>

#include <sstream>

#include <librfc/XMLDoc.hpp>

//#include <Resources/pling.xpm>

using namespace Auth4cUIComponents;

ExceptionDialog::ExceptionDialog( QWidget* pparent, const Auth4cData::Exception& eNA )
	: QDialog( pparent ),
	_bExpanded( false ),
	_peNA( &eNA )
{
    setupUi(this); //Setup the Qt Designer generated widgets

	setWindowIcon( Auth4cUIComponents::icon4c() );

	QRect rect( 0, 0, 300, 140 );
	_plblLegend->setParent( _pwdgLegend );
	_pedtLegend->setParent( _pwdgLegend );
	_pwdgLegend->setGeometry( rect );
	_plblLegend->setGeometry( rect );
	_pedtLegend->setGeometry( rect );

	_pedtLegend->hide();
	_pedtLegend->setReadOnly( true );

	if( NULL != _peNA )
	{
		setWindowTitle( QString::fromStdString( _peNA->explainErrorCode( _peNA->errorCode() ) ) );
		_plblLegend->setText( QString::fromStdString( _peNA->legend() ) );
		std::ostringstream os;
		os << *_peNA;
		_pedtLegend->setPlainText( QString::fromStdString( os.str() ) );
	}
}

ExceptionDialog::~ExceptionDialog()
{
}

void ExceptionDialog::accept()
{
	QDialog::accept();
}

void ExceptionDialog::reject()
{
	QDialog::reject();
}

void ExceptionDialog::help()
{
	_bExpanded = !_bExpanded;

	if( _bExpanded )
	{
		_pedtLegend->show();
		_plblLegend->hide();
	}
	else
	{
		_plblLegend->show();
		_pedtLegend->hide();
	}
}

void ExceptionDialog::copy()
{
	Rfc::XMLDoc docX( "auth4cservice", "1.0" );
	Rfc::XMLNode* pnodeX = docX.rootNode();
	pnodeX->attribute( "type", "usm" );

	if( NULL != _peNA )
	{
		Auth4cDataXML::Factory::Exception::toXML( pnodeX, *_peNA );
	}

	QApplication::clipboard()->setText( (const char*)docX.stream() );
}
