#include <Auth4cUIComponents/SplashWidget.h>

#include <QLabel>
#include <QFont>
#include <QPixmap>
#include <QApplication>

#include <MakeVersion.in>

using namespace Auth4cUIComponents;

SplashWidget::SplashWidget( QWidget* pparent )
	: QWidget( pparent )
{
	resize( 480, 330 );
	QPixmap pm( ":/Auth4cUIComponents/Resources/splash.png" );

	_plblSplash = new QLabel( this );
	_plblSplash->setGeometry( 0, 0, 480, 330 );
	_plblSplash->setPixmap( pm );

	_plblAuth4cManager = new QLabel( _plblSplash );
	_plblVersion = new QLabel( _plblSplash );
	_plblCopyright = new QLabel( _plblSplash );
//	_plblVersionDaemon = new QLabel( _plblSplash );
	_plblProgress = new QLabel( _plblSplash );

	_plblAuth4cManager->setGeometry( 200, 20, 180, 30 );
	_plblVersion->setGeometry( 200, 50, 100, 20 );
	_plblCopyright->setGeometry( 200, 65, 200, 80 );
//	_plblVersionDaemon->setGeometry( 200, 145, 200, 20 );
	_plblProgress->setGeometry( 20, 260, 400, 40 );

	QFont font( _plblAuth4cManager->font() );
	font.setWeight( QFont::Bold );
	font.setPointSize( font.pointSize() + 4 );
	_plblAuth4cManager->setFont( font );

	Base4c::Version version( AUTH4CVERSION );
	QString strVersion( tr( "Version " ) );
	strVersion += QString::fromStdString( version.textLS() );

	_plblCopyright->setWordWrap( true );

	_plblAuth4cManager->setText( tr( "Antique Manager" ) );
	_plblVersion->setText( strVersion );
	_plblCopyright->setText( QString::fromUtf8( "Copyright (c) 2016,\n  The 4c Company." ) );
}

SplashWidget::~SplashWidget()
{
}

/*void SplashWidget::setDaemonVersion( const NavtechFTT::Version& version )
{
	QString str( tr( "Daemon version ") );
	str += QString::fromStdString( version.textLS() );

	_plblVersionDaemon->setText( str );

	QApplication::processEvents();
}*/

void SplashWidget::setProgress( const QString& strMessage /*= QString()*/ )
{
	_plblProgress->setText( strMessage );

	QApplication::processEvents();
}
