/*

  $Id: UserTreeWidget.cpp 403 2015-12-10 14:13:42Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#include <Auth4cUIComponents/UserTreeWidget.h>

#include <Auth4cDataXML/Auth4cFactory.h>
#include <Auth4cUIComponents/TreeWidgetItem.h>

#include <QDateTime>
#include <QListWidgetItem>

using namespace Auth4cUIComponents;

UserTreeWidget::UserTreeWidget( QWidget* pparent )
	: QWidget( pparent )

{
    setupUi(this); //Setup the Qt Designer generated widgets

	Auth4cData::TeamMap& teamS = Auth4cDataXML::Factory::teams();
	for( Auth4cData::TeamMap::iterator iterTeam = teamS.begin();
			iterTeam != teamS.end();
			++iterTeam )
	{
		new Auth4cUIComponents::TeamTreeWidgetItem( _ptreeUser, &iterTeam->second, Auth4cUIComponents::TreeWidgetItem::Unchecked );
	}
}

UserTreeWidget::~UserTreeWidget()
{
}

void UserTreeWidget::selection( Auth4cData::TeamMap& teamS, Auth4cData::UserMap& userS )
{
	teamS.clear();
	userS.clear();

	QList<QTreeWidgetItem*> pteamS( _ptreeUser->findItems( "", Qt::MatchContains ) );

	for( QList<QTreeWidgetItem*>::const_iterator iterT = pteamS.begin();
			iterT != pteamS.end();
			++iterT )
	{
		// Teams
		Auth4cUIComponents::TeamTreeWidgetItem* pitemTeam = static_cast<Auth4cUIComponents::TeamTreeWidgetItem*>( *iterT );

		if( Qt::Checked == pitemTeam->checkState( 0 ) )
		{
			teamS[( (Auth4cData::Team*)pitemTeam->base() )->team()] = *( (Auth4cData::Team*)pitemTeam->base() );
		}

		QList<QTreeWidgetItem*> puserS( pitemTeam->takeChildren() );
		for( QList<QTreeWidgetItem*>::const_iterator iterU = puserS.begin();
				iterU != puserS.end();
				++iterU )
		{
			Auth4cUIComponents::TeamMemberTreeWidgetItem* pitemTeamMember = static_cast<Auth4cUIComponents::TeamMemberTreeWidgetItem*>( *iterU );

			if( Qt::Checked == pitemTeamMember->checkState( 0 ) )
			{
				userS[( (Auth4cData::User*)pitemTeamMember->base() )->key()] = *( (Auth4cData::TeamMember*)pitemTeamMember->base() );
			}
		}
	}
}

void UserTreeWidget::accept()
{
}

void UserTreeWidget::reject()
{
}

void UserTreeWidget::onExpanded( QTreeWidgetItem* pitem )
{
	Auth4cUIComponents::TreeWidgetItem* pitemC = static_cast<Auth4cUIComponents::TreeWidgetItem*>( pitem );
	pitemC->expanded();
}

void UserTreeWidget::onCMReq( const QPoint& point )
{
	QTreeWidgetItem* pitem = _ptreeUser->itemAt( point );
	if( NULL != pitem )
	{
		Auth4cUIComponents::TreeWidgetItem* pitemTree = static_cast<Auth4cUIComponents::TreeWidgetItem*>( pitem );
		pitemTree->doMenu();
	}
	else
	{
	}
}
