/*

  $Id: Auth4cDApp.h 392 2015-12-08 20:12:38Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __auth4cd_Auth4cDApp_h__
#define __auth4cd_Auth4cDApp_h__

#include <auth4cd/ClientSocket.h>
#include <Base4c/Mutex.h>
#include <Base4c/Version.h>
#include <crypt.h>

void shutdown( int nSignal );
void ignore( int nSignal );
const char* signame( int nSignal );

const int nFailed = -1;
const int nHelp = -2;

namespace Auth4cD
{
	class Auth4cDApp
	{
		private:
			bool _bIsTerminating;
			bool _bFulfillmentThreadTerminated;
			bool _bListeningThreadTerminated;

			int _s;
			int _nPort;
			ClientSocketList _socketS;
			std::string _strPIDFile;
			std::string _strRC;
			std::string _strKeyDir;
			bool _bCancelPendingRequests;
			bool _bIdle;
			struct rsa_key _key;
			struct rsa_key _keyStatic;


		public:
			Auth4cDApp();
			virtual ~Auth4cDApp();

			int initInstance( int nArgc, char** pszArgvS );
			int run( int nStartCode );
			int exitInstance( int nEndCode );

			rsa_key& key();

			bool isTerminating() const;
			ClientSocketList& sockets();
			void shutdown();

			int generateKeyPair( const std::string& strEntropy );
			struct rsa_key keyStatic();

		protected:
			int acceptClient( ClientSocket* pclient );

#if defined (LINUX)
			static void* fulfillmentThread( void* pvContext );
			static void* listeningThread( void* pvContext );
#elif defined (_WINDOWS)
			static void fulfillmentThread( void* pvContext );
			static void listeningThread( void* pvContext );
#endif /* LINUX */

	};

	const Base4c::Version& version();
};

extern Auth4cD::Auth4cDApp theApp;

#endif /* !__auth4cd_Auth4cDApp_h__ */
